<script setup>
</script>

<script>
import jQuery from "jquery";
import Jszip from 'jszip';
import DataTable from 'datatables.net-vue3';
import DataTableLib from 'datatables.net-bs5';
import 'datatables.net-buttons-bs5';
import 'datatables.net-buttons/js/buttons.html5.mjs';
import DataTableResponsive from "datatables.net-bs5";
import axios from 'axios';
import $ from 'jquery';
import swal from 'sweetalert';
import Multiselect from '@vueform/multiselect'
import '@vueform/multiselect/themes/default.css'
// Configurar JSZip
window.JSZip = Jszip;

// Inicializar DataTables con las bibliotecas
DataTable.use(DataTableLib);
DataTable.use(DataTableResponsive);

document.addEventListener("DOMContentLoaded", function () {
  // Obtener la tabla DataTable
  const dataTable = $('#datatableConstancias').DataTable();

  // Agregar un evento de clic a los elementos con la clase "eliminar" dentro de la tabla
  

  dataTable.on("click", ".detalles", function (id) {
    const rowData = dataTable.row($(this).closest("tr")).data();
    if (rowData) {
      const id = rowData.id;
      window.location.href = route('constancias.show',rowData.folio)
      console.log(id);
    }
  });


});

export default {
  components: { DataTable, Multiselect },
  data() {
    return {
      products: null,

    
      columns: [
        { data: null, render: function (data, type, row, meta) { return `${meta.row + 1}` } },
        { data: 'folio' }, // Modifica esta línea
        { data: 'rfc' },
        {
  data: null,
  render: (data, type, row) => {
    if (data.sancionado == 1) {
      return 'Sancionado';
    } else { 
      return 'No sancionado';
    }
  }
},

{ data: 'user.nombreCompleto' },
        {
          data: null,
          defaultContent: '<a title="Detalles" href="#a" v-on:click="detalles(folio)" class="detalles text-warning"> <i class="mdi mdi-eye font-size-18" style="font-size: 18px;"></i></a>',
          targets: -1
        }
      ],
      botones: [
        {
          title: 'Reporte de bitacora de actividades',
          extend: 'excelHtml5',
          text: '<i class ="far fa-file-excel"></i> Descargar Excel',
          className: 'btn btn-success',
          exportOptions: {
        columns: [1,2, 3, 4,5] // Índices de las columnas a exportar (ajusta esto según tus necesidades)
    }
        }
      ]
    }
  },

  mounted() {
    const dataTable = $('#datatableConstancias').DataTable();
    this.getProducts();
    this.initDataTable();

    
  },

  props: {
	    variables: Object,
	},

  watch: {
	 
   

 },

  methods: {
    getProducts() {
      swal({
    icon: 'info',
    text: 'Cargando registros...',
    buttons: false,
    closeOnClickOutside: false,
    closeOnEsc: false,
  });
      axios.get(route('constancias.get.all')).then(
        response => {
          console.log(response.data.data)
          this.products = response.data.data
          swal.close();
        }
      )
    },
    

initDataTable() {
    const dataTable = $('#datatableConstancias').DataTable({

      dom: 'Bfrtip', // Agrega el contenedor de botones
    buttons: [
      {
        extend: 'excelHtml5', // Extensión para exportar a Excel
        title: 'Reporte de bitacora de actividades', // Título del archivo Excel
        text: '<i class ="mdi mdi-file-excel"></i> Descargar Excel',
        className: 'btn btn-success',
        exportOptions: {
        columns: [1,2, 3, 4,5] // Índices de las columnas a exportar (ajusta esto según tus necesidades)
    }
      },
    ],
      destroy: true,
      serverSide: true,
      ajax: {
        url: route('constancias.get.all'),
        type: 'GET',
        dataSrc: function (json) {
            json.recordsTotal = json.total;
            json.recordsFiltered = json.total;
            return json.data;
        },
        data: d => {
          d.page = (d.start / d.length) + 1;
        },
      },
      columns: this.columns,

      searching: true,

      
      

      language: {
          processing: "Procesando...",
          search: "Buscar:",
          lengthMenu: "Mostrar _MENU_ registros",
          info: "Mostrando desde _START_ al _END_ de _TOTAL_ registros",
          infoEmpty: "Mostrando ningún elemento.",
          infoFiltered: "(filtrado _MAX_ elementos total)",
          infoPostFix: "",
          loadingRecords: "Cargando registros...",
          zeroRecords: "No se encontraron registros",
          emptyTable: "No hay datos disponibles en la tabla",
          paginate: {
            first: "Primero",
            previous: "Anterior",
            next: "Siguiente",
            last: "Último"
          },
          aria: {
            sortAscending: ": activar para ordenar la columna ascendente",
            sortDescending: ": activar para ordenar la columna descendente"
          }
        },
      
    });
    
    dataTable.on('page.dt', () => {
      swal({
        icon: 'info',
        text: 'Cargando registros...',
        buttons: false,
        closeOnClickOutside: false,
        closeOnEsc: false,
      });
    });

    

    // Añadir un event listener para el evento 'draw'.
    dataTable.on('draw.dt', () => {
      setTimeout(() => {
    swal.close();
  }, 4000);
    });
  },


  }
}
</script>

<template>

        <div class="row">
          <div class="col-lg-12">
            <div class="card">
              <div class="card-body">
                <h4 class="card-title mb-4">Historial de constancias</h4>
                <div class="table-responsive">
                  <DataTable :data="products" :columns="columns" id="datatableConstancias" class=" table-condensed table table-bordered dt-responsive  nowrap w-100"
                    :options="{responsive:true,autoWidth:false, dom:'Bfrtip',language:{
                      search: 'Buscar', zeroRecords:'No hay registros para mostrar',
                      info:'Mostrando del _START_ a _END_ de _TOTAL_ registros',
                      infoFiltered: '(Filtrados de _MAX_ registros.)',
                      paginate:{first: 'Primero',previous:'Anterior',next:'Siguiente', last:'Último'}
                    }, buttons:botones}">
                    <thead class="table-light">
                      <tr>
                        <th style="width: 5%;">
                        </th>
                        <th class="align-middle text-center" style="width: 20%;">Folio</th>
                        <th class="align-middle text-center" style="width: 20%;">RFC</th>
                        <th class="align-middle text-center" style="width: 20%;">Estado</th>
                        <th class="align-middle text-center" style="width: 20%;">Emisor</th>
                        <th class="align-middle text-center" style="width: 10%;">Acciones</th>

                      </tr>
                    </thead>
                    <tbody style="text-align: center; font-size: 15px;"></tbody>
                  </DataTable>
                </div>
              </div>
            </div>
          </div>
        </div>

    <footer class="footer"></footer>

</template>

<style>
.dataTables_wrapper .dataTables_filter {
  margin-right: 10px;
}

.dataTables_filter{
  display: none;
}

#datatableConstancias{
  margin-top: 10px;
}


.dt-buttons btn-group {
  background-color: red;
}

@media (min-width: 768px) {
  #TablaPrincipal_wrapper {}
}
</style>
